using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Collections;

namespace zadatak2 {

    public partial class Form1 : Form {

        private static Random r = new Random(DateTime.Now.Millisecond);
        private Button[,] matrica;
        private Color[] boje = new Color[4] { Color.Green, Color.Gold, Color.Coral, Color.Blue };
        private int[] brojac = new int[4] { 20, 20, 20, 20 };
        private int poeni, kliknuto;
        private Form2 forma2;
        private int brojCiklusa;
        private Boolean nijeKliknuo;
        private Color kliknutaBoja;

        public Form1() {
            InitializeComponent();
            matrica = new Button[10, 10];
            nijeKliknuo = true;
            kliknutaBoja = Color.Empty;

            int sirina = this.ClientRectangle.Width / 10;
            int visina = this.ClientRectangle.Height / 10;

            for (int i = 0; i < 10; i++) {
                for (int j = 0; j < 10; j++) {
                    matrica[i, j] = new Button();
                    matrica[i, j].Click += new System.EventHandler(this.button1_Click);
                    matrica[i, j].SetBounds(j * sirina, i * visina, sirina, visina);
                    this.Controls.Add(matrica[i, j]);
                }
            }

            promeniBoje();

            forma2 = new Form2(this);
            forma2.Show();
            timer1.Stop();
            Enabled = false;
        }

        public void promeniBoje() {
            int g = 20; int random = -1;

            Boolean fleg = false;
            int[] brojac1 = new int[4] { 20, 20, 20, 20 };

            do {
                random = r.Next(0, 4);
                if (brojac1[random] == 30) continue;
                else brojac1[random]++;
                g--;
            } while (g > 0);

            for (int i = 0; i < brojac1.Length; i++)
                brojac[i] = brojac1[i];

            for (int i = 0; i < 10; i++) {
                for (int j = 0; j < 10; j++) {
                    do {
                        fleg = false;
                        random = r.Next(0, 4);
                        if (brojac1[random] == 0) fleg = true;
                        else brojac1[random]--;
                    } while (fleg == true);
                    matrica[i, j].BackColor = boje[random];
                }
            }
        }

        private void timer1_Tick(object sender, EventArgs e) {
            timer1.Stop();
            forma2.Button1.Show();            
            if (nijeKliknuo) poeni -= 10;
            if (brojCiklusa == 10) { this.Hide(); forma2.Button1.Hide(); }            
            forma2.Labela1.Text = "Poeni: " + poeni + "\r\n\n";
            if(!kliknutaBoja.IsEmpty) forma2.Labela1.Text += "Kliknuta " + kliknutaBoja.Name + "\r\n\n";
            for (int i = 0; i < brojac.Length; i++)
                forma2.Labela1.Text += boje[i].Name + ": " + brojac[i] + "\r\n";
            brojCiklusa++;
            nijeKliknuo = true;
        }

        private void button1_Click(object sender, EventArgs e) {
            Enabled = false;
            kliknutaBoja = ((Button)sender).BackColor;
            for (int i = 0; i < boje.Length; i++)
                if (((Button)sender).BackColor == boje[i]) kliknuto = i;
            Boolean veciJe = true;
            for (int i = 0; i < brojac.Length; i++)
                if (brojac[kliknuto] < brojac[i]) veciJe = false;
            if (veciJe) poeni += brojac[kliknuto];
            else poeni -= brojac[kliknuto];
            nijeKliknuo = false;
        }

        private void Form1_Resize(object sender, EventArgs e) {
            int sirina = this.ClientRectangle.Width / 10;
            int visina = this.ClientRectangle.Height / 10;
            for (int i = 0; i < 10; i++) {
                for (int j = 0; j < 10; j++) {
                    matrica[i, j].SetBounds(j * sirina, i * visina, sirina, visina);
                }
            }
        }

        private class Form2 : Form {
            private Form1 forma1;
            public Form2(Form1 forma1) {
                this.forma1 = forma1;
                InitializeComponent();
            }

            public Label Labela1 {
                get { return label1; }
                set { label1 = value; }
            }
            public Button Button1 {
                get { return button1; }
                set { button1 = value; }
            }

            private void button3_Click(object sender, EventArgs e) {
                forma1.Dispose();
            }

            private void button2_Click(object sender, EventArgs e) {
                forma1.timer1.Stop();
                forma1.poeni = 0;
                forma1.brojCiklusa = 0;
                label1.Text = "";
                forma1.Show(); button1.Show();      
            }

            private void button1_Click(object sender, EventArgs e) {
                button1.Hide();
                forma1.promeniBoje();
                forma1.Enabled = true;
                forma1.timer1.Start();
            }

            private System.ComponentModel.IContainer components = null;

            /// <summary>
            /// Clean up any resources being used.
            /// </summary>
            /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
            protected override void Dispose(bool disposing) {
                if (disposing && (components != null)) {
                    components.Dispose();
                }
             base.Dispose(disposing);
             forma1.Dispose();
            }

            #region Windows Form Designer generated code

            /// <summary>
            /// Required method for Designer support - do not modify
            /// the contents of this method with the code editor.
            /// </summary>
            private void InitializeComponent() {
                this.button1 = new System.Windows.Forms.Button();
                this.label1 = new System.Windows.Forms.Label();
                this.button2 = new System.Windows.Forms.Button();
                this.button3 = new System.Windows.Forms.Button();
                this.SuspendLayout();
                // 
                // button1
                // 
                this.button1.Location = new System.Drawing.Point(83, 135);
                this.button1.Name = "button1";
                this.button1.Size = new System.Drawing.Size(75, 23);
                this.button1.TabIndex = 0;
                this.button1.Text = "Start/Next";
                this.button1.UseVisualStyleBackColor = true;
                this.button1.Click += new System.EventHandler(this.button1_Click);
                // 
                // label1
                // 
                this.label1.Location = new System.Drawing.Point(12, 9);
                this.label1.Name = "label1";
                this.label1.Size = new System.Drawing.Size(216, 105);
                this.label1.TabIndex = 1;
                // 
                // button2
                // 
                this.button2.Location = new System.Drawing.Point(2, 135);
                this.button2.Name = "button2";
                this.button2.Size = new System.Drawing.Size(75, 23);
                this.button2.TabIndex = 2;
                this.button2.Text = "New game";
                this.button2.UseVisualStyleBackColor = true;
                this.button2.Click += new System.EventHandler(this.button2_Click);
                // 
                // button3
                // 
                this.button3.Location = new System.Drawing.Point(164, 135);
                this.button3.Name = "button3";
                this.button3.Size = new System.Drawing.Size(75, 23);
                this.button3.TabIndex = 3;
                this.button3.Text = "Cancel";
                this.button3.UseVisualStyleBackColor = true;
                this.button3.Click += new System.EventHandler(this.button3_Click);
                // 
                // Form2
                // 
                this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
                this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
                this.ClientSize = new System.Drawing.Size(240, 160);
                this.Controls.Add(this.button3);
                this.Controls.Add(this.button2);
                this.Controls.Add(this.label1);
                this.Controls.Add(this.button1);
                this.Name = "Form2";
                this.Text = "Igra se 10 ciklusa po 3 sek !";
                this.ResumeLayout(false);

            }

            #endregion

            private System.Windows.Forms.Button button1;
            private System.Windows.Forms.Label label1;
            private System.Windows.Forms.Button button2;
            private System.Windows.Forms.Button button3;            
        }
    }
}